Subject: Re: [PATCH v2] tty: hvc: wakeup hvc console immediately when needed

From: Greg KH <[email-masked]>
Date: Mon, 15 Apr 2024 09:33:01 +0200

On Mon, Apr 15, 2024 at 03:26:17PM +0800, [email-masked] wrote:
> From: Li Hao <[email-masked]>
> 
> Cancel the do_wakeup flag in hvc_struct, and change it to immediately
> wake up tty when hp->n_outbuf is 0 in hvc_push().
> 
> When we receive a key input character, the interrupt handling function
> hvc_handle_interrupt() will be executed, and the echo thread
> flush_to_ldisc() will be added to the queue.
> 
> If the user is currently using tcsetattr(), a hang may occur. tcsetattr()
> enters kernel and waits for hp->n_outbuf to become 0 via
> tty_wait_until_sent(). If the echo thread finishes executing before
> reaching tty_wait_until_sent (for example, put_chars() takes too long),
> it will cause while meeting the wakeup condition (hp->do_wakeup = 1),
> tty_wait_until_sent() cannot be woken up (missed the tty_wakeup() of
> this round's tty_poll). Unless the next key input character comes,
> hvc_poll will be executed, and tty_wakeup() will be performed through
> the do_wakeup flag.
> 
> v1->v2:
> Some fixes according to:
> https://lore.kernel.org/all/[email-masked]/
>     use tty_port_tty_wakeup() instead of tty_wakeup() to wake up tty

As per the documentation, the v1... stuff needs to go below the --- line
so git will strip it away.

Please fix up and send a v3.

thanks,

greg k-h